package experiments;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.GeneralSecurityException;

import org.apache.poi.poifs.crypt.AgileDecryptor;
import org.apache.poi.poifs.crypt.Decryptor;
import org.apache.poi.poifs.crypt.EncryptionInfo;
import org.apache.poi.poifs.filesystem.NPOIFSFileSystem;

public class TestDecryptor {

	
	public static void main(String[] args) throws IOException {
		String file = "./encrypted.xlsx";
		processEncrypted(file);
	}
	
	
	private static void processEncrypted(String file) throws FileNotFoundException, IOException {
		try {
		    InputStream dataStream = getDecryptedInputStream(file);

	    	System.out.println("Reading input stream...");
		    FileOutputStream outStream = new FileOutputStream(file + "_decrypted");
		    byte[] buffer = new byte[1024*16];
		    int read;
		    while ((read = dataStream.read(buffer)) > -1) {
		    	System.out.println("  "  + read + " B");
		    	outStream.write(buffer, 0, read);
		    }
		    dataStream.close();
		    outStream.close();
		    System.out.println("Decryption sccessful");
		    
		} catch (GeneralSecurityException ex) {
		    throw new RuntimeException("Unable to process encrypted document", ex);
		}
	}
	
	public static InputStream getDecryptedInputStream(String file) throws FileNotFoundException, IOException, GeneralSecurityException {
		NPOIFSFileSystem fs = new NPOIFSFileSystem(new File(file));
		
		EncryptionInfo info = new EncryptionInfo(fs);
		Decryptor d = Decryptor.getInstance(info);
		if (d instanceof AgileDecryptor) {
			//d = new FixedAgileDecryptor(info);
		}

    	System.out.print("Verifying password... ");
	    if (!d.verifyPassword("aaa")) {
	    	System.out.println("FAILED");
	        throw new RuntimeException("Unable to process: document is encrypted");
	    }
    	System.out.println("OK");

	    return d.getDataStream(fs);
	}

}
